#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include "sdlfunc.h"
#include "BFont.h"
#include "mapa.h"
#include "video.h"

//SDL_Surface *screen;
//SDL_Event evento;

/*struct TTileMap
{
   SDL_Surface *Tela;
   SDL_Surface **TileSrc;
   SDL_Rect DstRect;
   int **MapaSrc;
   int TileX;
   int TileY;
   int TileW;
   int TileH;
   int TileBpp;
   int NumTiles;
   //int PosX;
   //int PosY;
};*/

//funcao que carrega um mapa de tile
int CarregaTileMap(struct TTileMap Mapa,char *path)
{
   FILE *arquivo;
   int CountX;
   int CountY;
   int Count;
   int CCount;
   int X;
   int Y;
   int Tamanho;
   Uint16 Ponto;
   
   //abre o arquivo (char * path)
   arquivo = fopen(path,"r");
   //verificacao de erro
   if (arquivo == NULL)
     {
	
	printf("Nao foi Possivel Carregar o mapa.:%s \n",&path);
	exit (0);
     }
   
   
   //le TileX quantos tiles na largura
   if (fread(&Mapa.TileX,sizeof(int),1,arquivo) == -1)
     {
	
	printf("Nao foi Possivel ler mapa formato invalido.: %s\n",&path);
	exit(0);
     }
   
   
   //le TileY
   if (fread(&Mapa.TileY,sizeof(int),1,arquivo) == -1)
     {
	printf("Nao possivel ler o mapa formato invalido.: %s\n",&path);
	exit(0);
     }

   //le largura do Tile
   if (fread(&Mapa.TileW,sizeof(int),1,arquivo) == -1)
     {
	printf("Nao foi Possivel ler o mapa formato invalido.: %s\n",&path);
	exit(0);
     }
   
   //le altura do tile
   if (fread(&Mapa.TileH,sizeof(int),1,arquivo) == -1)
     {
	printf("Nao foi Possivel ler o mapa formato invalido.: %s\n",&path);
	exit(0);
     }
   //Numero de tiles
   if (fread(&Mapa.NumTiles,sizeof(int),1,arquivo) == -1)
     {
	printf("Nao foi possivel ler o map formato invalido.: %s\n",&path);
	exit(0);
     }
   
   //le Bpp dos Tile
   if (fread(&Mapa.TileBpp,sizeof(int),1,arquivo) == -1)
     {
	printf("Nao foi possivel ler o mapaformato invalido.: %s\n",&path);
	exit(0);
     }
   //calula o tamanho do mapa Aloca espoco na memoria e le
   
     
	
       CountX = Mapa.TileY;
       CountY = Mapa.TileX;
       //Aloca Linhas
       Mapa.MapaSrc = calloc(CountY,sizeof(int *));
	//Verifica
       if (Mapa.MapaSrc == NULL)
	 {
	     printf("Nao foi possivel arranjar espaco na memoria.\n");
	     exit(0);
	  }
	//Aloca Colunas
	for (Count=0;Count<CountX;Count++)
	  {
	     Mapa.MapaSrc[Count] = calloc(CountX,sizeof(int *));
	     //verifica
	     if (Mapa.MapaSrc[Count] == NULL)
	       {
		  printf("Nao foi possivel alocar espaco na memoria.\n");
		  exit(0);
	       }
	  }
	
	
	     //se chegou ate aqui o a matriz foi alocada
	     //agora vamos ler o mapa 
	for (Count=0;Count<CountY;Count++)
	  for (CCount=0;CCount<X;CCount++)
	    {
	       if (fread(&Mapa.MapaSrc[CountY][CountX],sizeof(int),1,arquivo) == -1)
		 {
		    printf("Nao foi possivel ler o mapa formato invalido.: %s\n",&path);
		    exit(0);
		 }
	    }
   
   
   
	//Agora vai Complicar um pouco por conveniencia eu deixei os
	//tiles guardados no mapa no Formato Uint16
	//entao eu vou ter que ler tile por tile e desenhar
	//ponto por ponto no Mapa.Src[Count]
	
  
     Mapa.TileSrc = calloc(Mapa.NumTiles,sizeof(SDL_Surface *));
    if (Mapa.TileSrc == NULL)
     {
	printf("erro id 1\n");
	exit(0);
     }
     /*
   switch (Mapa.TileBpp)
     {
      case 1:
	Tamanho = sizeof(Uint8);
      case 2:
	Tamanho = sizeof(Uint16);
      default:
	Tamanho = sizeof(Uint16);
     } */
   
   for (Count=0;Count<Mapa.NumTiles;Count++)
     {
	Mapa.TileSrc[Count] = SDL_CreateRGBSurface(SDL_SWSURFACE,Mapa.TileW,Mapa.TileH,Mapa.TileBpp,screen->format->Rmask,
					    screen->format->Gmask,screen->format->Bmask,screen->format->Amask);
	if (Mapa.TileSrc[Count] == NULL)
	  {
	     printf("Erro id 1.\n");
	     exit(0);
	  }
	
	for (Y=0;Y<Mapa.TileH;Y++)
	  for (X=0;X<Mapa.TileW;X++)
	    {
	       
	       if (fread(&Ponto,sizeof(Uint16),1,arquivo) ==-1)
		 {
		    printf("Nao foi possivel ler o mapa formato invalido");
		    exit(0);
		 }
	   MapPutPixel(Mapa.TileSrc[Count],X,Y,(Uint16)Ponto);
	    }
	//se chegou ate aqui carregou os tiles com sucesso
     }
   fclose(arquivo);
   return 1;
}

struct TTileMap CriaTileMap(char *pathtile,int tile_h,int tile_w,
		int NumTile,int linhas, int colunas)
{
  struct TTileMap Mapa;
   SDL_Surface *Bmp;
   SDL_Rect Rect;
   SDL_Rect DstRect;
   FILE *logfile;
   int Count;
   int y;
   int x;
   
//   logfile = fopen("log.txt","w+");
  // if (logfile != NULL)
  // fprintf(logfile,"Porra");
   Mapa.NumTiles = NumTile;
   Mapa.TileH = tile_h;
   Mapa.TileW = tile_w;
   Mapa.TileX = colunas;
   Mapa.TileY = linhas;
   DstRect.x = 0;
   DstRect.y = 0;
   DstRect.h = 16;
   DstRect.w = 16; 
   
   //dexar o espaco na memoria para a matriz MapaSrc
   printf("Alocalndo espaco na memoria para a matriz\n");
   Mapa.MapaSrc = calloc (Mapa.TileY,sizeof(int *));
   if (Mapa.MapaSrc == NULL)
     {
	printf("Nao foi possivel alocar espaco na memoria.\n");
	
     }
   
   printf("Alocando espaco para a matri\n");
   for (Count=0;Count<Mapa.TileY;Count++)
     {
	Mapa.MapaSrc[Count] = calloc(Mapa.TileX,sizeof(int));
	if (Mapa.MapaSrc[Count] == NULL)
	  {
	     printf("Nao foi possivel alocar espaco na memoria.\n");
	     exit(0);
	  }
     }
   
   //vamos comecar alocando os tiles cada um vai ocupar uma surface
   printf("Alocando espaco na memoria para imagens\n");
   Mapa.TileSrc = calloc(Mapa.NumTiles,sizeof(SDL_Surface *));
   if (Mapa.TileSrc == NULL)			 
       {
	  printf("Nao e possivel alocar o mapa memoria insufiente.\n");
	  exit (0);
       }
   printf("Espaco alocado %d\n",sizeof(Mapa.TileSrc));
   //a partir daqui vamos carregar os tile
   printf("Carregando Tiles\n");
   Bmp = IMG_Load(pathtile);
   if (Bmp == NULL)
     {
	printf("Erroa ao carregar tiles: %s\n",&pathtile);
	  exit(0);
     }
   
   //aki desenha os tiles em Tiles[]
   y=0;
   x=0;
   for(Count=0;Count<Mapa.NumTiles;Count++)
     {
	//x++;
	//x= x*16;
	if (x*Mapa.TileW >= Bmp->w)
	  {
	     y++;
	     x = 0;
	  }
	
	Rect.x = x * Mapa.TileW;
	Rect.y = y * Mapa.TileH;
	Rect.w = x * Mapa.TileW + Mapa.TileW;
	Rect.h = y * Mapa.TileH + Mapa.TileH;
	x++;
	//x = x * 16;
//	x++;
	  
	//cria surfaces
	//printf("Criando Surfaces\n");
	Mapa.TileSrc[Count] = SDL_CreateRGBSurface(SDL_SWSURFACE,16,Mapa.TileW,Mapa.TileH,
					    Bmp->format->Rmask,Bmp->format->Gmask,Bmp->format->Bmask,Bmp->format->Amask);
	if (Mapa.TileSrc[Count] == NULL)  
	  {
	     printf("Nao foi possivel Criar imagens");
	     exit(0);
	  }
	
	//desenha
	//printf("Desenhando.\n");
	
	
	if (SDL_BlitSurface(Bmp,&Rect,Mapa.TileSrc[Count],NULL) < 0)
	  {
	     printf("Erro ao desenhar imagens.\n");
	     exit(0);
	  }
	//MapPutPixel(Mapa.TileSrc[Count],8,8,0xffff);
       SDL_UpdateRect(Mapa.TileSrc[Count],0,0,0,0);
//       SDL_BlitSurface(Mapa.TileSrc[Count],NULL,screen,&Rect);
	
     }
   
   printf("Feito Com Sucesso\n");
   SDL_FreeSurface(Bmp);
   return (struct TTileMap)Mapa;
}

	   
/*int main()
{f
   return 0;
}*/
